diff -rupN arpack++1.2.orig/include/ardnsmat.h arpack++1.2.patched/include/ardnsmat.h
--- arpack++1.2.orig/include/ardnsmat.h	2000-02-21 20:58:26.000000000 +0100
+++ arpack++1.2.patched/include/ardnsmat.h	2006-01-26 15:37:49.000000000 +0100
@@ -20,7 +20,8 @@
 #ifndef ARDNSMAT_H
 #define ARDNSMAT_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "armat.h"
 #include "arerror.h"
@@ -126,9 +127,9 @@ Copy(const ARdsNonSymMatrix<ARTYPE, ARFL
 
   // Copying very fundamental variables and user-defined parameters.
 
-  m         = other.m;
-  n         = other.n;
-  defined   = other.defined;
+  this->m         = other.m;
+  this->n         = other.n;
+  this->defined   = other.defined;
   factored  = other.factored;
   info      = other.info;
   A         = other.A;
@@ -145,11 +146,11 @@ Copy(const ARdsNonSymMatrix<ARTYPE, ARFL
 
   // Copying vectors.
 
-  Ainv = new ARTYPE[m*n];
-  ipiv = new int[n];
+  Ainv = new ARTYPE[this->m*this->n];
+  ipiv = new int[this->n];
 
-  copy(m*n, other.Ainv, 1, Ainv, 1);
-  for (int i=0; i<n; i++) ipiv[i] = other.ipiv[i];
+  copy(this->m*this->n, other.Ainv, 1, Ainv, 1);
+  for (int i=0; i<this->n; i++) ipiv[i] = other.ipiv[i];
 
 } // Copy.
 
@@ -159,8 +160,8 @@ inline void ARdsNonSymMatrix<ARTYPE, ARF
 {
 
   ClearMem();
-  Ainv = new ARTYPE[m*n];
-  ipiv = new int[n];
+  Ainv = new ARTYPE[this->m*this->n];
+  ipiv = new int[this->n];
 
 } // CreateStructure.
 
@@ -187,11 +188,11 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined or is rectangular.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsNonSymMatrix::FactorA");
   }
 
-  if (m!=n) {
+  if (this->m!=this->n) {
     throw ArpackError(ArpackError::NOT_SQUARE_MATRIX,
                       "ARdsNonSymMatrix::FactorA");
   }
@@ -207,11 +208,11 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Copying A to Ainv;
 
-  ::copy(m*n, A, 1, Ainv, 1);
+  ::copy(this->m*this->n, A, 1, Ainv, 1);
 
   // Decomposing A.
 
-  getrf(m, n, Ainv, m, ipiv, info);
+  getrf(this->m, this->n, Ainv, this->m, ipiv, info);
 
   // Handling errors.
 
@@ -228,12 +229,12 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined or is rectangular.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED,
                       "ARdsNonSymMatrix::FactorAsI");
   }
 
-  if (m!=n) {
+  if (this->m!=this->n) {
     throw ArpackError(ArpackError::NOT_SQUARE_MATRIX,
                       "ARdsNonSymMatrix::FactorAsI");
   }
@@ -249,12 +250,12 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Subtracting sigma*I from A.
 
-  ::copy(m*n,A,1,Ainv,1);
-  for (int i=0; i<(m*n); i+=m+1) Ainv[i]-=sigma;
+  ::copy(this->m*this->n,A,1,Ainv,1);
+  for (int i=0; i<(this->m*this->n); i+=this->m+1) Ainv[i]-=sigma;
 
   // Decomposing AsI.
 
-  getrf(m, n, Ainv, m, ipiv, info);
+  getrf(this->m, this->n, Ainv, this->m, ipiv, info);
 
   // Handling errors.
 
@@ -279,7 +280,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsNonSymMatrix::MultMv");
   }
 
@@ -287,14 +288,14 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   if (mat.IsOutOfCore()) {
 
-    if (m>n) { 
+    if (this->m>this->n) { 
 
       // Matrix is "tall".
 
       mat.Rewind();
       for (i=0; i<mat.NBlocks(); i++) {
         mat.ReadBlock();
-        gemv("N", mat.RowsInMemory(), n, one, mat.Entries(), 
+        gemv("N", mat.RowsInMemory(), this->n, one, mat.Entries(), 
              mat.RowsInMemory(), v, 1, zero, &w[mat.FirstIndex()], 1);
       }
 
@@ -305,12 +306,12 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
       mat.Rewind();
       t = new ARTYPE[mat.ColsInMemory()];
-      for (i=0; i<m; i++) w[i] = zero;
+      for (i=0; i<this->m; i++) w[i] = zero;
       for (i=0; i<mat.NBlocks(); i++) {
         mat.ReadBlock();
-        gemv("N", m, mat.ColsInMemory(), one, mat.Entries(), 
-             m, &v[mat.FirstIndex()], 1, zero, t, 1);
-        axpy(m, one, t, 1, w, 1); 
+        gemv("N", this->m, mat.ColsInMemory(), one, mat.Entries(), 
+             this->m, &v[mat.FirstIndex()], 1, zero, t, 1);
+        axpy(this->m, one, t, 1, w, 1); 
       }
       delete[] t;
 
@@ -319,7 +320,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   }
   else {
 
-    gemv("N", m, n, one, A, m, v, 1, zero, w, 1);
+    gemv("N", this->m, this->n, one, A, this->m, v, 1, zero, w, 1);
 
   }
 
@@ -340,7 +341,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsNonSymMatrix::MultMtv");
   }
 
@@ -348,15 +349,15 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   if (mat.IsOutOfCore()) {
 
-    if (m<=n) { 
+    if (this->m<=this->n) { 
 
       // Matrix is "fat".
 
       mat.Rewind();
       for (i=0; i<mat.NBlocks(); i++) {
         mat.ReadBlock();
-        gemv("T", m, mat.ColsInMemory(), one, mat.Entries(), 
-             m, v, 1, zero, &w[mat.FirstIndex()], 1);
+        gemv("T", this->m, mat.ColsInMemory(), one, mat.Entries(), 
+             this->m, v, 1, zero, &w[mat.FirstIndex()], 1);
       }
 
     }
@@ -366,10 +367,10 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
       mat.Rewind();
       t = new ARTYPE[mat.ColsInMemory()];
-      for (i=0; i<m; i++) w[i] = zero;
+      for (i=0; i<this->m; i++) w[i] = zero;
       for (i=0; i<mat.NBlocks(); i++) {
         mat.ReadBlock();
-        gemv("T", mat.RowsInMemory(), n, one, mat.Entries(), 
+        gemv("T", mat.RowsInMemory(), this->n, one, mat.Entries(), 
              mat.RowsInMemory(), &v[mat.FirstIndex()], 1, zero, t, 1);
         axpy(mat.RowsInMemory(), one, t, 1, w, 1); 
       }
@@ -380,7 +381,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   }
   else {
 
-    gemv("T", m, n, one, A, m, v, 1, zero, w, 1);
+    gemv("T", this->m, this->n, one, A, this->m, v, 1, zero, w, 1);
 
   }
 
@@ -400,22 +401,22 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   one  = (ARTYPE)0 + 1.0;
   zero = (ARTYPE)0;
 
-  if (mat.IsOutOfCore() && (m>n)) {
+  if (mat.IsOutOfCore() && (this->m>this->n)) {
 
     // Special code for "tall" matrices.
 
     t = new ARTYPE[mat.BlockSize()];
-    s = new ARTYPE[n];
+    s = new ARTYPE[this->n];
 
     mat.Rewind();
-    for (i=0; i<n; i++) w[i] = zero;
+    for (i=0; i<this->n; i++) w[i] = zero;
     for (i=0; i<mat.NBlocks(); i++) {
       mat.ReadBlock();
-      gemv("N", mat.RowsInMemory(), n, one, mat.Entries(), 
+      gemv("N", mat.RowsInMemory(), this->n, one, mat.Entries(), 
            mat.RowsInMemory(), v, 1, zero, t, 1);
-      gemv("T", mat.RowsInMemory(), n, one, mat.Entries(), 
+      gemv("T", mat.RowsInMemory(), this->n, one, mat.Entries(), 
            mat.RowsInMemory(), t, 1, zero, s, 1);
-      axpy(n, one, s, 1, w, 1); 
+      axpy(this->n, one, s, 1, w, 1); 
 
     }
 
@@ -425,7 +426,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   }
   else {
 
-    t = new ARTYPE[m];
+    t = new ARTYPE[this->m];
 
     MultMv(v,t);
     MultMtv(t,w);
@@ -450,22 +451,22 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   one  = (ARTYPE)0 + 1.0;
   zero = (ARTYPE)0;
 
-  if (mat.IsOutOfCore() && (m<=n)) {
+  if (mat.IsOutOfCore() && (this->m<=this->n)) {
 
     // Special code for "fat" matrices.
 
     t = new ARTYPE[mat.BlockSize()];
-    s = new ARTYPE[m];
+    s = new ARTYPE[this->m];
 
     mat.Rewind();
-    for (i=0; i<m; i++) w[i] = zero;
+    for (i=0; i<this->m; i++) w[i] = zero;
     for (i=0; i<mat.NBlocks(); i++) {
       mat.ReadBlock();
-      gemv("T", m, mat.ColsInMemory(), one, mat.Entries(), 
-           m, v, 1, zero, t, 1);
-      gemv("N", m, mat.ColsInMemory(), one, mat.Entries(), 
-           m, t, 1, zero, s, 1);
-      axpy(m, one, s, 1, w, 1); 
+      gemv("T", this->m, mat.ColsInMemory(), one, mat.Entries(), 
+           this->m, v, 1, zero, t, 1);
+      gemv("N", this->m, mat.ColsInMemory(), one, mat.Entries(), 
+           this->m, t, 1, zero, s, 1);
+      axpy(this->m, one, s, 1, w, 1); 
 
     }
 
@@ -475,7 +476,7 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
   }
   else {
 
-    t = new ARTYPE[n];
+    t = new ARTYPE[this->n];
 
     MultMtv(v,t);
     MultMv(t,w);
@@ -491,8 +492,8 @@ template<class ARTYPE, class ARFLOAT>
 void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::Mult0MMt0v(ARTYPE* v, ARTYPE* w)
 {
 
-  MultMv(&v[m],w);
-  MultMtv(v,&w[m]);
+  MultMv(&v[this->m],w);
+  MultMtv(v,&w[this->m]);
 
 } // Mult0MMt0v.
 
@@ -510,11 +511,11 @@ void ARdsNonSymMatrix<ARTYPE, ARFLOAT>::
 
   // Overwritting w with v.
 
-  copy(n, v, 1, w, 1);
+  copy(this->n, v, 1, w, 1);
 
   // Solving A.w = v (or AsI.w = v).
 
-  getrs("N", n, 1, Ainv, m, ipiv, w, m, info);
+  getrs("N", this->n, 1, Ainv, this->m, ipiv, w, this->m, info);
 
   // Handling errors.
 
@@ -530,10 +531,10 @@ DefineMatrix(int np, ARTYPE* Ap)
 
   // Defining member variables.
 
-  n         = np;
-  m         = np;
+  this->n         = np;
+  this->m         = np;
   A         = Ap;
-  defined   = true;
+  this->defined   = true;
   Ainv      = NULL;
   ipiv      = NULL;
   info      = 0; 
@@ -548,10 +549,10 @@ DefineMatrix(int mp, int np, ARTYPE* Ap)
 
   // Defining member variables.
 
-  m         = mp;
-  n         = np;
+  this->m         = mp;
+  this->n         = np;
   A         = Ap;
-  defined   = true;
+  this->defined   = true;
   Ainv      = NULL;
   ipiv      = NULL;
   info      = 0;
diff -rupN arpack++1.2.orig/include/ardscomp.h arpack++1.2.patched/include/ardscomp.h
--- arpack++1.2.orig/include/ardscomp.h	2000-02-21 00:22:42.000000000 +0100
+++ arpack++1.2.patched/include/ardscomp.h	2006-01-26 15:37:49.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARDSCOMP_H
 #define ARDSCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arscomp.h"
 #include "ardnsmat.h"
@@ -84,7 +85,7 @@ inline void ARluCompStdEig<ARFLOAT>::
 ChangeShift(arcomplex<ARFLOAT> sigmaRp)
 {
 
-  objOP->FactorAsI(sigmaRp);
+  this->objOP->FactorAsI(sigmaRp);
   ARrcStdEig<ARFLOAT, arcomplex<ARFLOAT> >::ChangeShift(sigmaRp);
 
 } // ChangeShift.
@@ -96,7 +97,7 @@ inline void ARluCompStdEig<ARFLOAT>::Set
 
   ARStdEig<ARFLOAT, arcomplex<ARFLOAT>, 
            ARdsNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT> >::
-    SetRegularMode(objOP, 
+    SetRegularMode(this->objOP, 
                    &ARdsNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT>::MultMv);
 
 } // SetRegularMode.
@@ -109,7 +110,7 @@ SetShiftInvertMode(arcomplex<ARFLOAT> si
 
   ARStdEig<ARFLOAT, arcomplex<ARFLOAT>, 
            ARdsNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP,
+    SetShiftInvertMode(sigmap, this->objOP,
                        &ARdsNonSymMatrix<arcomplex<ARFLOAT>,ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
@@ -123,7 +124,7 @@ ARluCompStdEig(int nevp, ARdsNonSymMatri
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A,
                    &ARdsNonSymMatrix<arcomplex<ARFLOAT>, ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
@@ -154,7 +155,7 @@ operator=(const ARluCompStdEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/ardsmat.h arpack++1.2.patched/include/ardsmat.h
--- arpack++1.2.orig/include/ardsmat.h	2000-02-20 23:56:02.000000000 +0100
+++ arpack++1.2.patched/include/ardsmat.h	2006-01-26 15:37:49.000000000 +0100
@@ -20,7 +20,8 @@
 #ifndef ARDSMAT_H
 #define ARDSMAT_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "armat.h"
 #include "arerror.h"
@@ -110,9 +111,9 @@ Copy(const ARdsSymMatrix<ARTYPE>& other)
 
   // Copying very fundamental variables and user-defined parameters.
 
-  m         = other.m;
-  n         = other.n;
-  defined   = other.defined;
+  this->m         = other.m;
+  this->n         = other.n;
+  this->defined   = other.defined;
   factored  = other.factored;
   uplo      = other.uplo;
   info      = other.info;
@@ -124,11 +125,11 @@ Copy(const ARdsSymMatrix<ARTYPE>& other)
 
   // Copying vectors.
 
-  Ainv = new ARTYPE[(n*n+n)/2];
-  ipiv = new int[n];
+  Ainv = new ARTYPE[(this->n*this->n+this->n)/2];
+  ipiv = new int[this->n];
 
-  copy((n*n+n)/2, other.Ainv, 1, Ainv, 1);
-  for (int i=0; i<n; i++) ipiv[i] = other.ipiv[i];
+  copy((this->n*this->n+this->n)/2, other.Ainv, 1, Ainv, 1);
+  for (int i=0; i<this->n; i++) ipiv[i] = other.ipiv[i];
 
 } // Copy.
 
@@ -141,15 +142,15 @@ void ARdsSymMatrix<ARTYPE>::SubtractAsI(
 
   // Copying A to Ainv.
 
-  ::copy((n*n+n)/2 ,A, 1, Ainv, 1);
+  ::copy((this->n*this->n+this->n)/2 ,A, 1, Ainv, 1);
 
   // Subtracting sigma from diagonal elements.
 
   if (uplo=='L') {
-    for (i=0, j=0; i<n; j+=(n-(i++))) Ainv[j] -= sigma;
+    for (i=0, j=0; i<this->n; j+=(this->n-(i++))) Ainv[j] -= sigma;
   }
   else {
-    for (i=0, j=0; i<n; j+=(++i)) Ainv[j] -= sigma;
+    for (i=0, j=0; i<this->n; j+=(++i)) Ainv[j] -= sigma;
   }
 
 } // SubtractAsI.
@@ -160,8 +161,8 @@ inline void ARdsSymMatrix<ARTYPE>::Creat
 {
 
   ClearMem();
-  Ainv = new ARTYPE[(n*n+n)/2];
-  ipiv = new int[n];
+  Ainv = new ARTYPE[(this->n*this->n+this->n)/2];
+  ipiv = new int[this->n];
 
 } // CreateStructure.
 
@@ -188,7 +189,7 @@ void ARdsSymMatrix<ARTYPE>::FactorA()
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsSymMatrix::FactorA");
   }
 
@@ -198,11 +199,11 @@ void ARdsSymMatrix<ARTYPE>::FactorA()
 
   // Copying A to Ainv;
 
-  ::copy((n*n+n)/2 ,A, 1, Ainv, 1);
+  ::copy((this->n*this->n+this->n)/2 ,A, 1, Ainv, 1);
 
   // Decomposing A.
 
-  sptrf(&uplo, n, Ainv, ipiv, info);
+  sptrf(&uplo, this->n, Ainv, ipiv, info);
 
   // Handling errors.
 
@@ -219,7 +220,7 @@ void ARdsSymMatrix<ARTYPE>::FactorAsI(AR
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsSymMatrix::FactorAsI");
   }
 
@@ -233,7 +234,7 @@ void ARdsSymMatrix<ARTYPE>::FactorAsI(AR
 
   // Decomposing AsI.
 
-  sptrf(&uplo, n, Ainv, ipiv, info);
+  sptrf(&uplo, this->n, Ainv, ipiv, info);
 
   // Handling errors.
 
@@ -254,26 +255,26 @@ void ARdsSymMatrix<ARTYPE>::MultMv(ARTYP
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARdsSymMatrix::MultMv");
   }
 
   // Determining w = M.v (unfortunately, the BLAS does not 
   // have a routine that works with packed matrices).
 
-  for (i=0; i<n; i++) w[i] = zero;
+  for (i=0; i<this->n; i++) w[i] = zero;
 
   if (uplo=='L') {
  
-    for (i=0, j=0; i<n; j+=(n-(i++))) {
-      w[i] += dot(n-i, &A[j], 1, &v[i], 1);
-      axpy(n-i-1, v[i], &A[j+1], 1, &w[i+1], 1);
+    for (i=0, j=0; i<this->n; j+=(this->n-(i++))) {
+      w[i] += dot(this->n-i, &A[j], 1, &v[i], 1);
+      axpy(this->n-i-1, v[i], &A[j+1], 1, &w[i+1], 1);
     }
  
   }  
   else { // uplo = 'U'
 
-    for (i=0, j=0; i<n; j+=(++i)) {
+    for (i=0, j=0; i<this->n; j+=(++i)) {
       w[i] += dot(i+1, &A[j], 1, v, 1);
       axpy(i, v[i], &A[j], 1, w, 1);
     }
@@ -296,11 +297,11 @@ void ARdsSymMatrix<ARTYPE>::MultInvv(ART
 
   // Overwritting w with v.
 
-  copy(n, v, 1, w, 1);
+  copy(this->n, v, 1, w, 1);
 
   // Solving A.w = v (or AsI.w = v).
 
-  sptrs(&uplo, n, 1, Ainv, ipiv, w, n, info);
+  sptrs(&uplo, this->n, 1, Ainv, ipiv, w, this->n, info);
 
   // Handling errors.
 
@@ -316,11 +317,11 @@ DefineMatrix(int np, ARTYPE* Ap, char up
 
   // Defining member variables.
 
-  m         = np;
-  n         = np;
+  this->m         = np;
+  this->n         = np;
   uplo      = uplop;
   A         = Ap;
-  defined   = true;
+  this->defined   = true;
   Ainv      = NULL;
   ipiv      = NULL;
   info      = 0; 
@@ -345,7 +346,7 @@ operator=(const ARdsSymMatrix<ARTYPE>& o
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/ardsnsym.h arpack++1.2.patched/include/ardsnsym.h
--- arpack++1.2.orig/include/ardsnsym.h	2000-02-21 00:14:18.000000000 +0100
+++ arpack++1.2.patched/include/ardsnsym.h	2006-01-26 15:37:49.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARDSNSYM_H
 #define ARDSNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arsnsym.h"
 #include "ardnsmat.h"
@@ -81,13 +82,13 @@ inline void ARluNonSymStdEig<ARFLOAT>::
 ChangeShift(ARFLOAT sigmaRp)
 {
 
-  sigmaR    = sigmaRp;
-  sigmaI    = 0.0;
-  mode      = 3;
-  iparam[7] = mode;
+  this->sigmaR    = sigmaRp;
+  this->sigmaI    = 0.0;
+  this->mode      = 3;
+  this->iparam[7] = this->mode;
 
-  objOP->FactorAsI(sigmaR);
-  Restart();
+  this->objOP->FactorAsI(this->sigmaR);
+  this->Restart();
 
 } // ChangeShift.
 
@@ -97,7 +98,7 @@ inline void ARluNonSymStdEig<ARFLOAT>::S
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARdsNonSymMatrix<ARFLOAT, ARFLOAT> >::
-    SetRegularMode(objOP, &ARdsNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv);
+    SetRegularMode(this->objOP, &ARdsNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv);
 
 } // SetRegularMode.
 
@@ -107,7 +108,7 @@ inline void ARluNonSymStdEig<ARFLOAT>::S
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARdsNonSymMatrix<ARFLOAT, ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP, 
+    SetShiftInvertMode(sigmap, this->objOP, 
                        &ARdsNonSymMatrix<ARFLOAT, ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
@@ -121,7 +122,7 @@ ARluNonSymStdEig(int nevp, ARdsNonSymMat
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A, 
                    &ARdsNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
@@ -151,7 +152,7 @@ operator=(const ARluNonSymStdEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
@@ -160,4 +161,3 @@ operator=(const ARluNonSymStdEig<ARFLOAT
 
 
 #endif // ARDSNSYM_H
-
diff -rupN arpack++1.2.orig/include/ardssym.h arpack++1.2.patched/include/ardssym.h
--- arpack++1.2.orig/include/ardssym.h	2000-02-21 00:09:40.000000000 +0100
+++ arpack++1.2.patched/include/ardssym.h	2006-01-26 15:37:49.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARDSSYM_H
 #define ARDSSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arssym.h"
 #include "ardsmat.h"
@@ -81,13 +82,13 @@ inline void ARluSymStdEig<ARFLOAT>::
 ChangeShift(ARFLOAT sigmaRp)
 {
 
-  sigmaR    = sigmaRp;
-  sigmaI    = 0.0;
-  mode      = 3;
-  iparam[7] = mode;
+  this->sigmaR    = sigmaRp;
+  this->sigmaI    = 0.0;
+  this->mode      = 3;
+  this->iparam[7] = this->mode;
 
-  objOP->FactorAsI(sigmaR);
-  Restart();
+  this->objOP->FactorAsI(this->sigmaR);
+  this->Restart();
 
 } // ChangeShift.
 
@@ -97,7 +98,7 @@ inline void ARluSymStdEig<ARFLOAT>::SetR
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARdsSymMatrix<ARFLOAT> >::
-    SetRegularMode(objOP, &ARdsSymMatrix<ARFLOAT>::MultMv);
+    SetRegularMode(this->objOP, &ARdsSymMatrix<ARFLOAT>::MultMv);
 
 } // SetRegularMode.
 
@@ -107,7 +108,7 @@ inline void ARluSymStdEig<ARFLOAT>::SetS
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARdsSymMatrix<ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP, &ARdsSymMatrix<ARFLOAT>::MultInvv);
+    SetShiftInvertMode(sigmap, this->objOP, &ARdsSymMatrix<ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
 
@@ -119,7 +120,7 @@ ARluSymStdEig(int nevp, ARdsSymMatrix<AR
               int maxitp, ARFLOAT* residp, bool ishiftp)
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A, &ARdsSymMatrix<ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -147,7 +148,7 @@ operator=(const ARluSymStdEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
@@ -156,4 +157,3 @@ operator=(const ARluSymStdEig<ARFLOAT>& 
 
 
 #endif // ARDSSYM_H
-
diff -rupN arpack++1.2.orig/include/arerror.h arpack++1.2.patched/include/arerror.h
--- arpack++1.2.orig/include/arerror.h	2000-03-01 19:59:37.000000000 +0100
+++ arpack++1.2.patched/include/arerror.h	2006-01-26 15:37:49.000000000 +0100
@@ -29,9 +29,10 @@
 #ifndef ARERROR_H
 #define ARERROR_H
 
+#include <iostream>
+#include <cstdlib>
+
 #include "arch.h"
-#include <iostream.h>
-#include <stdlib.h>
 
 class ArpackError {
 
@@ -151,8 +152,8 @@ inline void ArpackError::Print(const cha
 {
 
 #ifndef ARPACK_SILENT_MODE
-  cerr << "Arpack error in " << where << "." << endl;
-  cerr << "-> " << message << "." << endl;
+  std::cerr << "Arpack error in " << where << "." << std::endl;
+  std::cerr << "-> " << message << "." << std::endl;
 #endif
 
 } // Print
diff -rupN arpack++1.2.orig/include/argcomp.h arpack++1.2.patched/include/argcomp.h
--- arpack++1.2.orig/include/argcomp.h	2000-02-21 00:49:24.000000000 +0100
+++ arpack++1.2.patched/include/argcomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARGCOMP_H
 #define ARGCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arscomp.h"
 #include "argeig.h"
@@ -83,7 +84,7 @@ ARCompGenEig(int np, int nevp, ARFOP* ob
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, objBp, MultBxp,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -114,7 +115,7 @@ operator=(const ARCompGenEig<ARFLOAT, AR
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
@@ -123,4 +124,3 @@ operator=(const ARCompGenEig<ARFLOAT, AR
 
 
 #endif // ARGCOMP_H
-
diff -rupN arpack++1.2.orig/include/argeig.h arpack++1.2.patched/include/argeig.h
--- arpack++1.2.orig/include/argeig.h	2000-02-21 00:39:06.000000000 +0100
+++ arpack++1.2.patched/include/argeig.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,7 +19,8 @@
 #ifndef ARGEIG_H
 #define ARGEIG_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "arrgeig.h"
@@ -149,7 +150,7 @@ ChangeMultBx(ARFB* objBp, void (ARFB::* 
 
   objB   = objBp;
   MultBx = MultBxp;
-  Restart();
+  this->Restart();
 
 } // ChangeMultBx.
 
@@ -158,46 +159,46 @@ template<class ARFLOAT, class ARTYPE, cl
 int ARGenEig<ARFLOAT, ARTYPE, ARFOP, ARFB>::FindArnoldiBasis()
 {
 
-  if (!BasisOK) Restart();
+  if (!this->BasisOK) this->Restart();
 
   // Changing to auto shift mode.
 
-  if (!AutoShift) {
+  if (!this->AutoShift) {
     ArpackError::Set(ArpackError::CHANGING_AUTOSHIFT, "FindArnoldiBasis");
-    AutoShift=true;
+    this->AutoShift=true;
   }
 
   // ARPACK main loop.
 
-  while (!BasisOK) {
+  while (!this->BasisOK) {
 
     // Calling Aupp.
 
-    try { TakeStep(); }
+    try { this->TakeStep(); }
     catch (ArpackError) {
       ArpackError(ArpackError::CANNOT_FIND_BASIS, "FindArnoldiBasis");
       return 0;
     }
 
-    switch (ido) {
+    switch (this->ido) {
     case -1:
 
       // Performing y <- OP*B*x for the first time when mode != 2.
 
-      if (mode != 2) {
-        ipntr[3] = ipntr[2]+n; // not a clever idea, but...
-        (objB->*MultBx)(&workd[ipntr[1]],&workd[ipntr[3]]);
+      if (this->mode != 2) {
+        this->ipntr[3] = this->ipntr[2]+this->n; // not a clever idea, but...
+        (this->objB->*MultBx)(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[3]]);
       }
 
     case  1:
 
       // Performing y <- OP*w.
 
-      if (mode == 2) { // w = x if mode = 2.
-        (objOP->*MultOPx)(&workd[ipntr[1]],&workd[ipntr[2]]);
+      if (this->mode == 2) { // w = x if mode = 2.
+        (this->objOP->*(this->MultOPx))(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[2]]);
       }
       else {           // w = B*x otherwise.
-        (objOP->*MultOPx)(&workd[ipntr[3]],&workd[ipntr[2]]);
+        (this->objOP->*(this->MultOPx))(&this->workd[this->ipntr[3]],&this->workd[this->ipntr[2]]);
       }
       break;
 
@@ -205,11 +206,11 @@ int ARGenEig<ARFLOAT, ARTYPE, ARFOP, ARF
 
       // Performing y <- B*x.
 
-      (objB->*MultBx)(&workd[ipntr[1]],&workd[ipntr[2]]);
+      (this->objB->*MultBx)(&this->workd[this->ipntr[1]],&this->workd[this->ipntr[2]]);
 
     }
   }
-  return nconv;
+  return this->nconv;
 
 } // FindArnoldiBasis.
 
@@ -220,7 +221,7 @@ operator=(const ARGenEig<ARFLOAT, ARTYPE
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/argnsym.h arpack++1.2.patched/include/argnsym.h
--- arpack++1.2.orig/include/argnsym.h	2000-02-21 19:21:34.000000000 +0100
+++ arpack++1.2.patched/include/argnsym.h	2006-01-26 15:48:23.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARGNSYM_H
 #define ARGNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "blas1c.h"
 #include "lapackc.h"
@@ -94,7 +95,7 @@ class ARNonSymGenEig:
 
  // d.3) Constructors and destructor.
 
-  ARNonSymGenEig() { part = 'R'; }
+  ARNonSymGenEig() { this->part = 'R'; }
   // Short constructor (Does nothing but calling base classes constructors).
 
   ARNonSymGenEig(int np, int nevp, ARFOP* objOPp,
@@ -148,7 +149,7 @@ Copy(const ARNonSymGenEig<ARFLOAT, ARFOP
   ARGenEig<ARFLOAT, ARFLOAT, ARFOP, ARFB>::Copy(other);
   objA   = other.objA;
   MultAx = other.MultAx;
-  part   = other.part;
+  this->part   = other.part;
 
 } // Copy.
 
@@ -161,22 +162,22 @@ void ARNonSymGenEig<ARFLOAT, ARFOP, ARFB
   ARFLOAT  numr, numi, denr, deni;
   ARFLOAT* Ax;
 
-  Ax = new ARFLOAT[n];
+  Ax = new ARFLOAT[this->n];
 
-  for (j=0; j<nconv; j++) {
+  for (j=0; j<this->nconv; j++) {
 
-    ColJ   = j*n;
-    ColJp1 = ColJ+n;
+    ColJ   = j*this->n;
+    ColJp1 = ColJ+this->n;
 
-    if (EigValI[j] == (ARFLOAT)0.0) {
+    if (this->EigValI[j] == (ARFLOAT)0.0) {
 
       // Eigenvalue is real. Computing EigVal = x'(Ax)/x'(Mx).
 
-      (objB->*MultAx)(&EigVec[ColJ], Ax);
-      numr = dot(n, &EigVec[ColJ], 1, Ax, 1);
-      (objB->*MultBx)(&EigVec[ColJ], Ax);
-      denr = dot(n, &EigVec[ColJ], 1, Ax, 1);
-      EigValR[j] =  numr / denr;
+      (this->objB->*MultAx)(&this->EigVec[ColJ], Ax);
+      numr = dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
+      (this->objB->*(this->MultBx))(&this->EigVec[ColJ], Ax);
+      denr = dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
+      this->EigValR[j] =  numr / denr;
 
     }
     else {
@@ -185,32 +186,32 @@ void ARNonSymGenEig<ARFLOAT, ARFOP, ARFB
 
       // Computing x'(Ax).
 
-      (objB->*MultAx)(&EigVec[ColJ], Ax);
-      numr = dot(n, &EigVec[ColJ], 1, Ax, 1);
-      numi = dot(n, &EigVec[ColJp1], 1, Ax, 1);
-      (objB->*MultAx)(&EigVec[ColJp1], Ax);
-      numr = numr + dot(n, &EigVec[ColJp1], 1, Ax, 1);
-      numi = -numi + dot(n, &EigVec[ColJ], 1, Ax, 1);
+      (this->objB->*MultAx)(&this->EigVec[ColJ], Ax);
+      numr = dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
+      numi = dot(this->n, &this->EigVec[ColJp1], 1, Ax, 1);
+      (this->objB->*MultAx)(&this->EigVec[ColJp1], Ax);
+      numr = numr + dot(this->n, &this->EigVec[ColJp1], 1, Ax, 1);
+      numi = -numi + dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
 
       // Computing x'(Mx).
 
-      (objB->*MultBx)(&EigVec[ColJ], Ax);
-      denr = dot(n, &EigVec[ColJ], 1, Ax, 1);
-      deni = dot(n, &EigVec[ColJp1], 1, Ax, 1);
-      (objB->*MultBx)(&EigVec[ColJp1], Ax);
-      denr = denr + dot(n, &EigVec[ColJp1], 1, Ax, 1);
-      deni = -deni + dot(n, &EigVec[ColJ], 1, Ax, 1);
+      (this->objB->*(this->MultBx))(&this->EigVec[ColJ], Ax);
+      denr = dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
+      deni = dot(this->n, &this->EigVec[ColJp1], 1, Ax, 1);
+      (this->objB->*(this->MultBx))(&this->EigVec[ColJp1], Ax);
+      denr = denr + dot(this->n, &this->EigVec[ColJp1], 1, Ax, 1);
+      deni = -deni + dot(this->n, &this->EigVec[ColJ], 1, Ax, 1);
 
       // Computing the first eigenvalue of the conjugate pair.
 
-      EigValR[j] = (numr*denr+numi*deni) / lapy2(denr, deni);
-      EigValI[j] = (numi*denr-numr*deni) / lapy2(denr, deni);
+      this->EigValR[j] = (numr*denr+numi*deni) / lapy2(denr, deni);
+      this->EigValI[j] = (numi*denr-numr*deni) / lapy2(denr, deni);
 
       // Getting the second eigenvalue of the conjugate pair by taking
       // the conjugate of the first.
 
-      EigValR[j+1] = EigValR[j];
-      EigValI[j+1] = -EigValI[j];
+      this->EigValR[j+1] = this->EigValR[j];
+      this->EigValI[j+1] = -this->EigValI[j];
       j++;
 
     }
@@ -228,9 +229,9 @@ SetShiftInvertMode(ARFLOAT sigmaRp, ARFO
                    void (ARFOP::* MultOPxp)(ARFLOAT[], ARFLOAT[]))
 {
 
-  part    = 'R';
-  objOP   = objOPp;
-  MultOPx = MultOPxp;
+  this->part    = 'R';
+  this->objOP   = objOPp;
+  this->MultOPx = MultOPxp;
   ChangeShift(sigmaRp);
 
 } // SetShiftInvertMode.
@@ -244,11 +245,11 @@ SetComplexShiftMode(char partp, ARFLOAT 
                     ARFB* objAp, void (ARFB::* MultAxp)(ARFLOAT[], ARFLOAT[]))
 {
 
-  objOP   = objOPp;
-  MultOPx = MultOPxp;
+  this->objOP   = objOPp;
+  this->MultOPx = MultOPxp;
   objA    = objAp;
   MultAx  = MultAxp;
-  part    = CheckPart(partp);
+  this->part    = this->CheckPart(partp);
   ChangeShift(sigmaRp, sigmaIp);
 
 } // SetComplexShiftMode.
@@ -258,9 +259,9 @@ template<class ARFLOAT, class ARFOP, cla
 inline int ARNonSymGenEig<ARFLOAT, ARFOP, ARFB>::FindEigenvalues()
 {
 
-  nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindEigenvalues();
-  if (sigmaI != 0.0) RecoverEigenvalues();
-  return nconv;
+  this->nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindEigenvalues();
+  if (this->sigmaI != 0.0) RecoverEigenvalues();
+  return this->nconv;
 
 } // FindEigenvalues.
 
@@ -269,9 +270,9 @@ template<class ARFLOAT, class ARFOP, cla
 inline int ARNonSymGenEig<ARFLOAT, ARFOP, ARFB>::FindEigenvectors(bool schurp)
 {
 
-  nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindEigenvectors(schurp);
-  if (sigmaI != 0.0) RecoverEigenvalues();
-  return nconv;
+  this->nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindEigenvectors(schurp);
+  if (this->sigmaI != 0.0) RecoverEigenvalues();
+  return this->nconv;
 
 } // FindEigenvectors.
 
@@ -280,9 +281,9 @@ template<class ARFLOAT, class ARFOP, cla
 int ARNonSymGenEig<ARFLOAT, ARFOP, ARFB>::FindSchurVectors()
 {
 
-  nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindSchurVectors();
-  if (sigmaI != 0.0) RecoverEigenvalues();
-  return nconv;
+  this->nconv = ARStdEig<ARFLOAT, ARFLOAT, ARFOP>::FindSchurVectors();
+  if (this->sigmaI != 0.0) RecoverEigenvalues();
+  return this->nconv;
 
 } // FindSchurVectors.
 
@@ -297,8 +298,8 @@ ARNonSymGenEig(int np, int nevp, ARFOP* 
 
 {
 
-  part = 'R';                // Considering mode = 3 in ChangeShift.
-  NoShift();
+  this->part = 'R';                // Considering mode = 3 in ChangeShift.
+  this->NoShift();
   DefineParameters(np, nevp, objOPp, MultOPxp, objBp, MultBxp,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -349,7 +350,7 @@ operator=(const ARNonSymGenEig<ARFLOAT, 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
